// Klac - header

#ifndef IG_KLAC_COMMON_HEADER_AS
#define IG_KLAC_COMMON_HEADER_AS

#define STR_TITLE ("~Klac " + STR_VERSION)
#define STR_VERSION "ver " + VER_MAJOR + "." + strf("%%02d", VER_MINOR) + VER_POSTFIX
#define VER_MAJOR   3
#define VER_MINOR   2
#define VER_POSTFIX ""

#enum IDW_MAIN = 0

#include "Klac/Klac.as"

#include "Mo/GetOwnpath.as"
#include "Mo/MCMultiString.as"
#include "Mo/MCIni.as"

#enum ProcMode_Calc = 0
;#enum ProcMode_DefFunc
#enum ProcMode_MAX

#define global stt_cfg _stt_cfg@klac_app_header		// ini IuWFNg

#module strcalc_app_header

#include "Klac/enum_valtype.as"
#include "Klac/header_inner.as"

// @private ownpath
// @static
	dim stt_cfg

#deffunc init@klac_app_header

	// INI t@C̃pXݒ
	sdim ownpath, MAX_PATH
	ownpath = GetOwnpath("H:/Docs/prg/hsp/ProjSmall/Klac")
	ini_new stt_cfg, ownpath + "/Klac.ini"
	
	return
	
//------------------------------------------------
// ownpath ̎擾
//------------------------------------------------
#defcfunc GetAppPath
	return ownpath
	
//------------------------------------------------
// INI֐f[^ǂݍ
//------------------------------------------------
#deffunc DefineOuterFunction  local slist, local name;, local iFunc
	
	// o^
	MStr_new            slist
	MStr_chainCsvString slist, ini_get(stt_cfg, "Function", "@deflist")
	
	// 錾E`
	repeat MStr_size(slist)
		name = MStr_get(slist, cnt)
		if ( name == "" ) { continue }
		
		StrCalc_DefFuncGlobal name, ini_geti(stt_cfg, "Function/argc", name, 0), ini_gets(stt_cfg, "Function/expr", name)
	;	iFunc = stat
	loop
	
	MStr_delete slist
	return
	
//------------------------------------------------
// INI玮ǂݍݎs
//------------------------------------------------
#deffunc EvalInitExpr  local cntItems, local tmp, local tmp_vt
	
	// o^
	cntItems = ini_geti( stt_cfg, "InitExpr", "@cnt", 0 )
	if ( cntItems <= 0 ) { return }
	
	repeat cntItems
		tmp = StrCalc( ini_get(stt_cfg, "InitExpr", str(cnt)), tmp_vt )
	loop
	
	return
	
//------------------------------------------------
// 񎮂s
// 
// @result: Ԓl
//------------------------------------------------
#defcfunc EvalKlacExpr str src,  local result, local resVt, local evaler, local iFunc
	
	result = StrCalc( src, resVt )
	
	if ( StrCalc_GetError() ) {
	:*LOnCalcError
		result = "E: " + StrCalc_GetErrorMessage()
	;	resVt  = Valtype_Error
		
	// ʂ𔽉f
	} else {
		result = DecodeEvalElem( resVt, result )
	}
	
	return result
	
#global

	init@klac_app_header

#endif
