// Container Wrapper - ėpRei (bp)

#ifndef IG_ABDATA_CONTAINER_WRAPPER_AS
#define IG_ABDATA_CONTAINER_WRAPPER_AS

#include "abheader.as"
#include "container_impl.as"
#include "mod_nullmod.as"

//##############################################################################
//                Container
//##############################################################################
#define global Container_ClsName "Container"

#define global ContainerNull abdataNull

//##############################################################################
//                \zE
//##############################################################################
#define global Container_new(%1, %2 = 0, %3 = stt_zero@) Container_new_impl %1, %2, %3
#define global Container_delete(%1) ContainerImpl_delete abdataInsts(%1)

#module

//------------------------------------------------
// ꎞReiEIuWFNg̐
//------------------------------------------------
#deffunc Container_new_impl var self, int num, var vDefault,  local len
	
	// vf̎g
	len = length(abdataInsts_var)
	if ( len != 1 ) {
		if ( varuse( abdataInsts_var(len - 2) ) ) {		// uŌォ1O̗vfvgpĂ => Ɩ܂Ă => g
			abdataInsts_var(len * 2 - 1) = abNullmod	// null Ďg
			// Ō̗vf abNullmod ̃N[Ȃ̂ .varuse = 2 ƂȂAɎgpłȂ
		}
	}
	
	// Vvf
	ContainerImpl_new abdataInsts_var, num, vDefault : self = stat
	
	return
	
#define global ctype new_Container(%1 = 0, %2 = stt_zero@) new_Container_(%1, %2)

//------------------------------------------------
// ꎞReiEIuWFNg̐
//------------------------------------------------
#defcfunc new_Container_ int num, var vDefault,  local newObj
	Container_new newObj, num, vDefault
	return newObj
	
#global

//##############################################################################
//                o߁E֐
//##############################################################################

//################################################
//        擾n
//################################################
//------------------------------------------------
// l̎擾 ( ߌ` )
//------------------------------------------------
#define global Container_getv(%1, %2, %3 = 0) ContainerImpl_getv abdataInsts(%1), %2, %3
#define global Container_popv(%1, %2, %3 = 0) ContainerImpl_popv abdataInsts(%1), %2, %3

//------------------------------------------------
// l̎擾 ( ֐` )
//------------------------------------------------
#define global ctype Container_get(%1,%2=0) ContainerImpl_get(abdataInsts(%1), %2)
#define global ctype Container_pop(%1,%2=0) ContainerImpl_pop(abdataInsts(%1), %2)

//------------------------------------------------
// QƉ ( ߌ` )
//------------------------------------------------
#define global Container_clone(%1,%2,%3=0) ContainerImpl_clone abdataInsts(%1), %2, %3

//------------------------------------------------
// QƉ ( ֐` )
//------------------------------------------------
#define global ctype Container_ref(%1,%2=0) ContainerImpl_ref(abdataInsts(%1))

//------------------------------------------------
// 擪E̒l̎擾
// 
// @ get  >> const ȑ
// @ pop  >> vf͎菜
//------------------------------------------------
#define global ctype Container_get_front(%1)     ContainerImpl_get_front( abdataInsts(%1) )
#define global ctype Container_get_back(%1)      ContainerImpl_get_back ( abdataInsts(%1) )
#define global       Container_getv_front(%1,%2) ContainerImpl_getv_front abdataInsts(%1), %2
#define global       Container_getv_back(%1,%2)  ContainerImpl_getv_back  abdataInsts(%1), %2
#define global ctype Container_pop_front(%1)     ContainerImpl_pop_front( abdataInsts(%1) )
#define global ctype Container_pop_back(%1)      ContainerImpl_pop_back ( abdataInsts(%1) )
#define global       Container_popv_front(%1,%2) ContainerImpl_popv_front abdataInsts(%1), %2
#define global       Container_popv_back(%1,%2)  ContainerImpl_popv_back  abdataInsts(%1), %2

//------------------------------------------------
// ^̎擾 ( ֐` )
//------------------------------------------------
#define global ctype Container_vartype(%1,%2)    ContainerImpl_vartype( abdataInsts(%1), %2 )
#define global ctype Container_vartype_front(%1) ContainerImpl_vartype_front( abdataInsts(%1) )
#define global ctype Container_vartype_back(%1)  ContainerImpl_vartype_back( abdataInsts(%1) )

//################################################
//        ݒn
//################################################
//------------------------------------------------
// l̐ݒ
//------------------------------------------------
#define global Container_set(%1, %2, %3 = 0)  ContainerImpl_set  abdataInsts(%1), %2, %3
#define global Container_setv(%1, %2, %3 = 0) ContainerImpl_setv abdataInsts(%1), %2, %3

//################################################
//        n
//################################################
//------------------------------------------------
// }
//------------------------------------------------
#define global Container_insert(%1, %2, %3 = 0)  ContainerImpl_insert  abdataInsts(%1), %2, %3
#define global Container_insertv(%1, %2, %3 = 0) ContainerImpl_insertv abdataInsts(%1), %2, %3

//------------------------------------------------
// vf̔{
//------------------------------------------------
#define global Container_double(%1, %2, %3) ContainerImpl_double abdataInsts(%1), %2, %3

//------------------------------------------------
// 擪EŌւ̒ǉ
//------------------------------------------------
#define global Container_double_front(%1)   ContainerImpl_double_front abdataInsts(%1)
#define global Container_double_back(%1)    ContainerImpl_double_back  abdataInsts(%1)
#define global Container_push_front(%1,%2)  ContainerImpl_push_front   abdataInsts(%1), %2
#define global Container_pushv_front(%1,%2) ContainerImpl_pushv_front  abdataInsts(%1), %2
#define global Container_push_back(%1,%2)   ContainerImpl_push_back    abdataInsts(%1), %2
#define global Container_pushv_back(%1,%2)  ContainerImpl_pushv_back   abdataInsts(%1), %2

#define global Container_push  Container_push_back
#define global Container_pushv Container_pushv_back
#define global Container_add   Container_push_back

//------------------------------------------------
// 
//------------------------------------------------
#define global Container_remove(%1, %2)   ContainerImpl_remove       abdataInsts(%1), %2
#define global Container_remove_front(%1) ContainerImpl_remove_front abdataInsts(%1)
#define global Container_remove_back(%1)  ContainerImpl_remove_back  abdataInsts(%1)

//------------------------------------------------
// vfݒ
//------------------------------------------------
#define global Container_setSize(%1, %2)  ContainerImpl_setSize abdataInsts(%1), %2

//------------------------------------------------
// ړ
//------------------------------------------------
#define global Container_move(%1, %2, %3) ContainerImpl_move abdataInsts(%1), %2, %3

//------------------------------------------------
// 
//------------------------------------------------
#define global Container_swap(%1, %2, %3) ContainerImpl_swap       abdataInsts(%1), %2, %3
#define global Container_swap_front(%1)   ContainerImpl_swap_front abdataInsts(%1)
#define global Container_swap_back(%1)    ContainerImpl_swap_back  abdataInsts(%1)

//------------------------------------------------
// 
//------------------------------------------------
#define global Container_rotate(%1, %2 = 0, %3 = ArrayRangeEndDefault) ContainerImpl_rotate abdataInsts(%1), %2, %3

//------------------------------------------------
//  ( t] )
//------------------------------------------------
#define global Container_rotate_back(%1, %2 = 0, %3 = ArrayRangeEndDefault) ContainerImpl_rotate_back abdataInsts(%1), %2, %3

//------------------------------------------------
// ]
//------------------------------------------------
#define global Container_reverse(%1, %2 = 0, %3 = ArrayRangeEndDefault) ContainerImpl_reverse abdataInsts(%1), %2, %3

//##########################################################
//        Rei
//##########################################################
//------------------------------------------------
// [i] S
//------------------------------------------------
#define global Container_clear(%1) ContainerImpl_clear abdataInsts(%1)

//------------------------------------------------
// [i] A
//------------------------------------------------
#define global Container_chain(%1,%2) ContainerImpl_chain abdataInsts(%1), abdataInsts(%2)

//------------------------------------------------
// [i] 
//------------------------------------------------
#define global Container_copy(%1,%2) ContainerImpl_copy abdataInsts(%1), abdataInsts(%2)

//------------------------------------------------
// [i] 
//------------------------------------------------
#define global Container_exchange(%1,%2) ContainerImpl_exchange abdataInsts(%1), abdataInsts(%2)

//------------------------------------------------
// 
// 
// @alg: (based: Merge-Sort)
// @	1. ^^CvlŐ
// @	2. ^ => sɂrŐ
// @prm mode : SortMode_* (default: SortMode_Ascening)
//------------------------------------------------
#define global Container_sort(%1, %2 = SortMode_Ascending) ContainerImpl_sort abdataInsts(%1), %2

//##########################################################
//        q
//##########################################################
//------------------------------------------------
// [i] q::
//------------------------------------------------
#define global Container_iterInit(%1,%2) ContainerImpl_iterInit abdataInsts(%1), %2

//------------------------------------------------
// [i] q::XV
//------------------------------------------------
#define global ctype Container_iterNext(%1,%2,%3) ContainerImpl_iterNext( abdataInsts(%1), %2, %3 )

//##########################################################
//        Gn
//##########################################################
//------------------------------------------------
// [i] vf
//------------------------------------------------
#define global ctype Container_size(%1)  ContainerImpl_size (abdataInsts(%1))
#define global ctype Container_empty(%1) ContainerImpl_empty(abdataInsts(%1))
#define global Container_count  Container_size
#define global Container_length Container_size

//------------------------------------------------
// ͈̓`FbN
//------------------------------------------------
#define global ctype Container_isValid(%1,%2) ContainerImpl_isValid(abdataInsts(%1), %2)

//------------------------------------------------
// ۂ̗vfԍ𓾂
// @private
//------------------------------------------------
// #modcfunc local Container_getRealIndex int idx

//##########################################################
//        Z
//##########################################################
//------------------------------------------------
// vfr
//------------------------------------------------
#define global ctype Container_opCmpElem(%1,%2,%3) ContainerImpl_opCmpElem(abdataInsts(%1), %2, %3)

//##############################################################################
//                ÓIo߁E֐
//##############################################################################
//------------------------------------------------
// ʓIȔrZ
// 
// @(condition): lhs, rhs ̌^͈v
//------------------------------------------------
// #defcfunc opCompare@abdata_con_impl var lhs, var rhs

//##############################################################################
//                fobOp
//##############################################################################
/*
#ifdef _DEBUG
//*/

//------------------------------------------------
// fobOo
//------------------------------------------------
#define global Container_dbglog(%1) ContainerImpl_dbglog_ abdataInsts(%1), "%1"

/*
#else

#define global Container_dbglog(%1) :

#endif
//*/

	Container_new nullContainer		// null := abdataInsts[0]
	
//##############################################################################
//                TvEXNvg
//##############################################################################
#if 0

	Container_new    vSt
	Container_add    vSt, "Hello, world!"
	Container_add    vSt, 100
	Container_add    vSt, M_PI
	Container_dbglog vSt
	Container_move   vSt, 1, 2
	Container_dbglog vSt
	
	Container_insert vSt, 0x7FFFFFFF, 0
	Container_dbglog vSt
	
	Container_reverse vSt
	Container_dbglog  vSt
	
	// 
	Container_add    vSt, 39
	Container_add    vSt, 18782
	Container_add    vSt, 2943
	Container_add    vSt, "ABCD͖"
	Container_add    vSt, "Extra Strings"
	Container_add    vSt, sqrt(2)
	Container_add    vSt, sqrt(8)
	Container_add    vSt, sqrt(3)
	Container_dbglog vSt
	
	Container_sort   vSt, ;SortMode_Decending
	Container_dbglog vSt
	
	stop
	
#endif

#endif

/******
	
	ׂẴCX^X́ÃW[̐ÓIϐ (z) st_allinsts ǗB
	CX^X́Aۂɂ st_allinsts ̔zvfŊǗAidx 𗘗pW[֐ĂяóA
	ContainerImpl_(modfunc) st_allinsts@...(idx), ... ɕϊB
	
******/
