// GXP[vV[PX

#ifndef IG_MODULE_ESCAPE_SEQUENCE_AS
#define IG_MODULE_ESCAPE_SEQUENCE_AS

#include "mod_replace.as"

#module

#include "ctype.as"

/**
 * \n, \r : s(CRLF, LF)
 * \t : ^u
 * \0 : NULLI[
 * \x :  'x' (x ͔Cӂ1)
//*/

//------------------------------------------------
// Kp
//------------------------------------------------
#deffunc EscSeq_Apply var src
	StrReplace src, "\\", "__\\__"
	StrReplace src, "\n", "\\n"
	StrReplace src, "\r", "\\r"
	StrReplace src, "\t", "\\t"
	StrReplace src, "__\\__", "\\\\"
	return
	
//------------------------------------------------
// WJ
// 
// @ escseq Ȃ珑܂ȂB
//------------------------------------------------
#defcfunc EscSeq_ExpandOf str src_,  local src
	src = src_
	EscSeq_Expand src
	return src
	
#deffunc EscSeq_Expand var src,  local iDst, local c
;	iDst = 0
	if ( instr(src, 0, "\\") < 0 ) { return }
	
	repeat strlen(src) + 1
		c = peek(src, cnt)		// cnt  iSrc
		
		assert ( iDst <= cnt )
		
		if ( IsSJIS1st(c) ) {
			iDst += 2
			continue cnt + 2
			
		} elsif ( c == '\\' ) {
			switch ( peek(src, cnt + 1) )
				case '0':  c = 0    : swbreak
				case '\\':          : swbreak
				case 't':  c = '\t' : swbreak
				case 'r':  c = '\r' : swbreak
				case 'n':
					wpoke src, iDst, 0x0A0D : iDst += 2
					continue cnt + 2
					
			;	default: //
			swend
			
			poke src, iDst, c : iDst ++
			continue cnt + 2
		}
		
		if ( cnt != iDst ) {
			poke src, iDst, c
		}
		iDst ++
	loop
	
	poke src, iDst, 0 ;: iDst ++
	return
	
#global

#if 0
	v = "abc\\\\\t\\0\\n"
	mes v
	EscSeq_Expand v
	mes v + "."
	stop
#endif
	
#endif
