// Klac - header

#ifndef IG_KLAC_HEADER_AS
#define IG_KLAC_HEADER_AS

#include "enum_valtype.as"

//##############################################################################
//                }N
//##############################################################################

//##############################################################################
//                萔l
//##############################################################################
//------------------------------------------------
// G[萔
// 
// @synchronizing:
// @	Error   [_NeedValtype, _NeedValtype_Max]
// @	Valtype [_Error, _Mark)
//------------------------------------------------
#enum Error_None = 0
#enum Error_Msg					// (bZ[WG[)
#enum Error_Syntax				// ̕@G[
#enum Error_Bracket				// ʂ̑Ή
#enum Error_DivBy0				// 0 Z
#enum Error_Infinity			// 

#enum Error_NeedValtype			// (this) + Valtype_* Ƃł
#enum Error_NeedError = Error_NeedValtype
#enum Error_NeedIdent
#enum Error_NeedVar
#enum Error_NeedBool
#enum Error_NeedInt
#enum Error_NeedDouble
#enum Error_NeedString
#enum Error_NeedAssoc
#enum Error_NeedBlock
#enum Error_NeedFunc
#enum Error_NeedMethod
#enum Error_NeedPropaty
#enum Error_NeedValtype_Max

#enum Error_NeedLeftValue = Error_NeedValtype_Max		// ӒlKv
#enum Error_NeedPair			// yAKv
#enum Error_NeedVector			// vector Kv
#enum Error_NeedComplex			// complex Kv
#enum Error_NeedCallable		// callable Kv
#enum Error_NeedIndexable		// indexable Kv
#enum Error_NoResult			// ԒlȂ
#enum Error_UnknownResult		// Ԓl
#enum Error_NotMember			// ołȂ̂Az悤Ƃ
#enum Error_InvalidIndex		// Y̒lُ
#enum Error_Argc				// ُ̐
#enum Error_InvalidValue		// ُȒl
#enum Error_NoDefault			// ȗłȂ
#enum Error_UnSupported			// T|[gĂȂ@\
#enum Error_Max

//------------------------------------------------
// g[N̎
//------------------------------------------------
#enum TkType_Error = (-1)	// G[
#enum TkType_None  = 0		// JnEI[L

#enum TkType_Ident			// ʎq
#enum TkType_Int			// l
#enum TkType_Double			// l
#enum TkType_String			// 
#enum TkType_StrBlock		// 򕶎

#enum TkType_PrefixOp		// PZq::Ou(prefix)
#enum TkType_PostfixOp		// PZq::u(postfix)
#enum TkType_BinOp			// 񍀉Zq

#enum TkType_ParenL			// ۊ::
#enum TkType_ParenR			// ۊ::E
#enum TkType_ArgL			// ::
#enum TkType_ArgR			// ::E
#enum TkType_BlockL			// 򊇌:: "{"
#enum TkType_BlockR			// 򊇌::E "}"
#enum TkType_ArrayL			// z񊇌:: "["
#enum TkType_ArrayR			// z񊇌::E "]"
#enum TkType_IndexL			// Y:: "["
#enum TkType_IndexR			// Y::E "]"
#enum TkType_Comma			// J}
#enum TkType_Declare		// 錾
#enum TkType_TupleL			// l::
#enum TkType_TupleR			// l::E
#enum TkType_Omission		// ȗ (֐̈)

#enum TkType_PolyOp_Tuple	// Zq::l

#enum TkType_Blank			// 
#enum TkType_Operator		// Zq
#enum TkType_Max

//------------------------------------------------
// PZq::Ou
//------------------------------------------------
#enum PrefixOp_Min  = 0
#enum PrefixOp_Plus = 0		// +
#enum PrefixOp_Minus		// -
#enum PrefixOp_Inv			// /
#enum PrefixOp_Exp			// ^
#enum PrefixOp_Sqrt			// //
#enum PrefixOp_Not			// ~
#enum PrefixOp_Neg			// !
#enum PrefixOp_Func			// =>
#enum PrefixOp_Inc			// ++
#enum PrefixOp_Dec			// --
#enum PrefixOp_Max

#define ctype EnumRange_UniOp_LowPriory(%1)  ( PrefixOp_Plus <= (%1) && (%1) <= PrefixOp_Minus )	// * ̉
#define ctype EnumRange_UniOp_HighPriory(%1) ( PrefixOp_Inv  <= (%1) && (%1) <= PrefixOp_Dec )		// ^ ̉

//------------------------------------------------
// PZq::u
//------------------------------------------------
#enum PostfixOp_Fact = PrefixOp_Max	// !
#enum PostfixOp_Percent			// %
#enum PostfixOp_Inc				// ++
#enum PostfixOp_Dec				// --
#enum PostfixOp_Tuple			// ,
#enum PostfixOp_Snake			// ;
#enum PostfixOp_Call			// () (Ĕzuɐ)
#enum PostfixOp_Index			// [] (Ĕzuɐ)
#enum PostfixOp_Max

#define ctype EnumRange_UniOp_Prefix(%1)  ( PrefixOp_Plus  <= (%1) && (%1) < PrefixOp_Max  )	// Ou
#define ctype EnumRange_UniOp_Postfix(%1) ( PostfixOp_Fact <= (%1) && (%1) < PostfixOp_Max )	// u
#define ctype EnumRange_UniOp_List(%1)    ( (%1) == PostfixOp_Call || (%1) == PostfixOp_Index )	// Xg

//------------------------------------------------
// 񍀉Zq
//------------------------------------------------
#enum BinOp_Lv0 = PostfixOp_Max	// D惌x 0
#enum BinOp_Split = BinOp_Lv0		// ;

#enum BinOp_Lv1					// D惌x 1
#enum BinOp_Set = BinOp_Lv1			// :=
#enum BinOp_Swap					// <->

#enum BinOp_Lv2					// D惌x 2 (gp)
#enum BinOp_Lv3   = BinOp_Lv2	// D惌x 3
#enum BinOp_Tuple = BinOp_Lv3		// ,

#enum BinOp_Lv4					// D惌x 4
#enum BinOp_Pair = BinOp_Lv4		// :
#enum BinOp_Which					// ?

#enum BinOp_Lv5					// D惌x 5
#enum BinOp_NullOr = BinOp_Lv5		// ??

#enum BinOp_Lv6					// D惌x 6
#enum BinOp_Lambda = BinOp_Lv6		// =>

#enum BinOp_Lv7					// D惌x 7
#enum BinOp_LogImp = BinOp_Lv7		// -->

#enum BinOp_Lv8					// D惌x 8
#enum BinOp_LogOr = BinOp_Lv8		// ||
#enum BinOp_LogXor					// ~~

#enum BinOp_Lv9					// D惌x 9
#enum BinOp_LogAnd = BinOp_Lv9		// &&

#enum BinOp_Lv10				// D惌x 10
#enum BinOp_EqRf = BinOp_Lv10		// ===
#enum BinOp_NeRf					// !==
#enum BinOp_Eq						// ==
#enum BinOp_Ne						// !=

#enum BinOp_Lv11				// D惌x 11
#enum BinOp_Lt = BinOp_Lv11			// <
#enum BinOp_Gt						// >
#enum BinOp_LtEQ					// <=
#enum BinOp_GtEQ					// >=
#enum BinOp_Cmp						// <>
#enum BinOp_Belong					// <:

#enum BinOp_Lv12				// D惌x 12
#enum BinOp_ShiftL = BinOp_Lv12		// <<
#enum BinOp_ShiftR					// >>

#enum BinOp_Lv13				// D惌x 13
#enum BinOp_BitOr = BinOp_Lv13		// |
#enum BinOp_BitXor					// ~

#enum BinOp_Lv14				// D惌x 14
#enum BinOp_BitAnd = BinOp_Lv14		// &

#enum BinOp_Lv15				// D惌x 15
#enum BinOp_Add = BinOp_Lv15		// +
#enum BinOp_Sub						// -

#enum BinOp_Lv16				// D惌x 16
#enum BinOp_Trans = BinOp_Lv16		// +> (ϊ)

#enum BinOp_Lv17				// D惌x 17
#enum BinOp_Mul = BinOp_Lv17		// *
#enum BinOp_Div						// /
#enum BinOp_Mod						// %

#enum BinOp_Lv18				// D惌x 18
#enum BinOp_Pow = BinOp_Lv18		// ^  (p)
#enum BinOp_Root					// // ()

#enum BinOp_Lv19				// D惌x 19
#enum BinOp_Assoc = BinOp_Lv19		// .
#enum BinOp_AssocBind				// ->
#enum BinOp_Max

#define ctype EnumRange_BinOp_Assign(%1) ( BinOp_Set    <= (%1) && (%1) <= BinOp_Swap )
#define ctype EnumRange_BinOp_Log(%1)    ( BinOp_LogImp <= (%1) && (%1) <= BinOp_LogAnd )
#define ctype EnumRange_BinOp_RelRf(%1)  ( BinOp_EqRf   <= (%1) && (%1) <= BinOp_NeRf )
#define ctype EnumRange_BinOp_Rel(%1)    ( BinOp_EqRf   <= (%1) && (%1) <= BinOp_Cmp )
#define ctype EnumRange_BinOp_Cmp(%1)    ( BinOp_Lt     <= (%1) && (%1) <= BinOp_Cmp )
#define ctype EnumRange_BinOp_Bit(%1)    ( BinOp_ShiftL <= (%1) && (%1) <= BinOp_BitAnd )
#define ctype EnumRange_BinOp_Arith(%1)  ( BinOp_Add    <= (%1) && (%1) <= BinOp_Mod || BinOp_Pow <= (%1) && (%1) <= BinOp_Root )
#define ctype EnumRange_BinOp_Assoc(%1)  ( (%1) == BinOp_Assoc || (%1) == BinOp_AssocBind )

//------------------------------------------------
// gݍ݃vOCID
//------------------------------------------------
#enum PlugIn_Userdef = 0		// [U`֐
#enum PlugIn_System				// VXe
#enum PlugIn_Dev				// (Jp)
#enum PlugIn_Syntax				// \֐
#enum PlugIn_Type				// ^֐
#enum PlugIn_Operation			// Z֐
#enum PlugIn_Math				// w֐
#enum PlugIn_Max
#enum PlugIn_Outer = PlugIn_Max

//------------------------------------------------
// gݍ݊֐ID
//------------------------------------------------
#enum Func_System__ = 0
#enum Func_System_New
#enum Func_System_Namespace
#enum Func_System_Call
#enum Func_System_Apply
#enum Func_System_Index
#enum Func_System_Has
#enum Func_System_PropRemove
#enum Func_System_Sum
#enum Func_System_Prod
#enum Func_System_Argv			// ȍ~͈EӒlWJ
#enum Func_System_Argc
#enum Func_System_Bind
#enum Func_System_Using
#enum Func_System_RunOn
#enum Func_System_Cond
#enum Func_System_ValOf
#enum Func_System_Max

#enum Func_Dev_PutError = Func_System_Max
#enum Func_Dev_Decode
#enum Func_Dev_LcAssoc
;#enum Func_Dev_Logmes
#enum Func_Dev_Max

#enum Func_Syntax_Return = Func_Dev_Max
#enum Func_Syntax_Yield
#enum Func_Syntax_Break

#enum Func_Syntax_Do
#enum Func_Syntax_For
#enum Func_Syntax_Max

#enum Func_Type_Ident = Func_Syntax_Max
#enum Func_Type_Var
#enum Func_Type_Bool
#enum Func_Type_Int
#enum Func_Type_Double
#enum Func_Type_String
#enum Func_Type_Assoc
#enum Func_Type_Block
#enum Func_Type_Func
#enum Func_Type_Method
#enum Func_Type_Propaty
#enum Func_Type_RefArg

#enum Func_Type_Class		// ̑ (gݍ݌^ł͂Ȃ Type vOCKĂ)
#enum Func_Type_Vector
#enum Func_Type_Tuple
#enum Func_Type_Pair
#enum Func_Type_Complex
#enum Func_Type_Max

#define ctype TypeFuncToValtype(%1) ((%1) - Func_Type_Ident + Valtype_Ident)

#enum Func_Operate_Begin = Func_Type_Max
#enum Func_Operate_Max   = Func_Operate_Begin + BinOp_Max

#define ctype OperateFuncToOptype(%1) ((%1) - Func_Operate_Begin + PrefixOp_Plus)

#enum Func_Math_Zero = Func_Operate_Max
#enum Func_Math_Abs

#enum Func_Math_Sgn
#enum Func_Math_Round
#enum Func_Math_Floor
#enum Func_Math_Ceil

#enum Func_Math_Add
#enum Func_Math_Mul
#enum Func_Math_Average
#enum Func_Math_Gcd
#enum Func_Math_Lcm
#enum Func_Math_Maxf
#enum Func_Math_Minf

#enum Func_Math_Permutation		// P ()
#enum Func_Math_Combination		// C (g)
#enum Func_Math_CRepeated		// H (dg; Homogeneous product(Ď)̓)

#enum Func_Math_Pow
#enum Func_Math_Exp
#enum Func_Math_Log
#enum Func_Math_Ln
#enum Func_Math_Log10
#enum Func_Math_Root
#enum Func_Math_Sqrt

#enum Func_Math_Sin
#enum Func_Math_Cos
#enum Func_Math_Tan
#enum Func_Math_Atan

#enum Func_Math_Randomize
#enum Func_Math_Rnd

#enum Func_Math_Max

//------------------------------------------------
// gݍݕϐID
//------------------------------------------------
#enum Var__ = 0					// OԒlϐ _
;#enum Var__Expr					// Oϐ _expr
#enum Var_Null
#enum Var_True
#enum Var_False
#enum Var_Indet
#enum Var_Pi
#enum Var_E
#enum Var_TheAnswerToLifeTheUniverseAndEverything
#enum Var_ThisDefault
#enum Var_ArgumentsDefault
#enum Var_Max
#enum Var_Userdef = Var_Max

//------------------------------------------------
// s[h
//------------------------------------------------
#enum RunMode_None = 0
#enum RunMode_End  = RunMode_None	// S
#enum RunMode_Yield					// yield ^[A߂ĂĂȂ
#enum RunMode_Run					// (ʏs)
#enum RunMode_LitBlock				// 򃊃e̍\
#enum RunMode_LoopDo				// ֐̎s
#enum RunMode_LoopFor
#enum RunMode_LoopSum
#enum RunMode_Max

//------------------------------------------------
// I[h
//------------------------------------------------
#enum ExitMode_None = 0
#enum ExitMode_Normal = ExitMode_None	// ʏI
#enum ExitMode_Return					// return
#enum ExitMode_Yield					// yield
#enum ExitMode_Break					// break
#enum ExitMode_Continue					// continue ()
#enum ExitMode_Throw					// throw ()
#enum ExitMode_Max

//##############################################################################
//                
//##############################################################################
//------------------------------------------------
// 
//------------------------------------------------


#endif
