// StrCalc Plugin - tuple

#ifndef IG_STRCALC_PLUGIN_TUPLE_AS
#define IG_STRCALC_PLUGIN_TUPLE_AS

// l^(tuple)p̃vOC
// @ Az̉ZAZł̓ꏈA̗pāAZ𑽒lɑ΂čsB

#include "MCPlugin.as"
#include "MCVector.as"

#module _plg_tuple

#include "header_inner.as"

//------------------------------------------------
// 
//------------------------------------------------
#deffunc PluginTuple_Init
	
	// namespace Tuple
	plugin_New stt_env_global, "Tuple"
		plugin_tuple = stat
		assoc_tuple  = plugin_GetAssoc(plugin_tuple)
		
	;	vector_Ctor assoc_tuple			// vector ̃CX^Xɂ (; WJ̃G[΍)
		
	plugin_SetLabel plugin_tuple, *LProcFunc
	
	// extends Vector
	assoc_DefVar assoc_tuple, "prototype", (stt_assoc_vector), Valtype_Assoc
	
	plugin_DefFunc plugin_tuple, "ctor",     0, true : func_tuple_ctor     = stat
	
	plugin_DefFunc plugin_tuple, "toVector", 0, true : func_tuple_ToVector = stat
	
	// Z֐
	plugin_DefFunc plugin_tuple, "opInc",   0, true : func_tuple_OpInc   = stat
	plugin_DefFunc plugin_tuple, "opDec",   0, true : func_tuple_OpDec   = stat
	/*
	plugin_DefFunc plugin_tuple, "opPlus",  0, true : func_tuple_OpPlus  = stat
	plugin_DefFunc plugin_tuple, "opMinus", 0, true : func_tuple_OpMinus = stat
	plugin_DefFunc plugin_tuple, "opInv",   0, true : func_tuple_OpInv   = stat
	plugin_DefFunc plugin_tuple, "opExp",   0, true : func_tuple_OpExp   = stat
	plugin_DefFunc plugin_tuple, "opSqrt",  0, true : func_tuple_OpSqrt  = stat
	plugin_DefFunc plugin_tuple, "opNot",   0, true : func_tuple_OpNot   = stat
	
	plugin_DefFunc plugin_tuple, "opFact",    0, true : func_tuple_OpFact    = stat
	plugin_DefFunc plugin_tuple, "opPercent", 0, true : func_tuple_OpPercent = stat
	plugin_DefFunc plugin_tuple, "opCall",   -1, true : func_tuple_OpCall    = stat
	plugin_DefFunc plugin_tuple, "opIndex",  -1, true : func_tuple_OpIndex   = stat
	
	plugin_DefFunc plugin_tuple, "opCmp",  1, true : func_tuple_OpCmp  = stat
	
	plugin_DefFunc plugin_tuple, "opAdd",  1, true : func_tuple_OpAdd  = stat
	plugin_DefFunc plugin_tuple, "opSub",  1, true : func_tuple_OpSub  = stat
	plugin_DefFunc plugin_tuple, "opMul",  1, true : func_tuple_OpMul  = stat
	plugin_DefFunc plugin_tuple, "opDiv",  1, true : func_tuple_OpDiv  = stat
	plugin_DefFunc plugin_tuple, "opMod",  1, true : func_tuple_OpMod  = stat
	plugin_DefFunc plugin_tuple, "opPow",  1, true : func_tuple_OpPow  = stat
	plugin_DefFunc plugin_tuple, "opRoot", 1, true : func_tuple_OpRoot = stat
	
	assoc_DefVar assoc_tuple, "opTrans", FuncValue(plugin_tuple, func_tuple_OpMul), Valtype_Func	// (a b)  (a * b)
	//*/
	return plugin_tuple
	
//------------------------------------------------
// ̐ (MCTuple.as)
//------------------------------------------------
#defcfunc new_tuple int iEnv,  local self
	self = new_vector( iEnv )		// vector 𐶐
	
	vector_beTuple self
	
	return self
	
#defcfunc new_tuple_bySingle var value, int valtype, int iEnv,  local self
	self = new_tuple( iEnv )
	vector_PushBack self, value, valtype		// lǉ
	return self
	
#defcfunc new_tuple_byVector int src,  local self
	self = new_tuple( vector_GetEnv(src) )
	vector_Chain self, src						// src[] A
	return self
	
#deffunc tuple_Ctor int self
	vector_Ctor self
	;
	return self
	
#deffunc vector_BeTuple int self
	var_Set assoc_Find( self, "prototype" ), (stt_assoc_tuple), Valtype_Assoc
	return
	
//------------------------------------------------
// 
//------------------------------------------------
#define ctype SetResult(%1 = thisAssoc, %2 = Valtype_Assoc) result = (%1) : resVt = (%2)

#deffunc local _dummy_proc var lbProc, var thisEval, int thisAssoc, int iFunc, var result, var resVt, int arglist, int cntArgs, int iEnv,  \
	local tmp, local tmp_vt
	
*LProcFunc
	if ( thisAssoc == assocNull ) {
		PutError Error_InvalidValue
	}
	
	switch ( iFunc )
		
		case func_tuple_ctor:
			tuple_Ctor thisAssoc
			SetResult()
			swbreak
			
		case func_tuple_ToVector:
			var_Set assoc_Find( thisAssoc, "prototype" ), (stt_assoc_vector), Valtype_Assoc
			SetResult()
			swbreak
			
		default: assert
	swend
	
	/*
	result = new_tuple( iEnv )		// Ԓlp
	
	repeat vector_Size(thisAssoc)
		// evf
		tmp    = vector_Get(thisAssoc, cnt)
		tmp_vt = Valtype_Var
		
		// inc, dec
		if ( iFunc == func_tuple_OpInc || iFunc == func_tuple_OpDec ) {
			vector_PushBack result, evaler_ProcOpUni_Assign( thisEval, (iFunc - func_tuple_OpInc + PostfixOp_Inc), resVt, tmp, tmp_vt ), resVt
			continue
		}
		
		switch ( iFunc )
			// PZ
			default:
				assert
		swend
	loop
	//*/
	return
	
//------------------------------------------------
// iFunc  optype
//------------------------------------------------
#deffunc PluginTuple_FuncIdToOptype int iFunc
	
	return
	
#global

#endif
