// StrCalc - Cnv to depoland

#ifndef IG_MODULE_STRCALC_CNV_TO_DEPOLAND_AS
#define IG_MODULE_STRCALC_CNV_TO_DEPOLAND_AS

#include "Mo/abdata/queue.as"
#include "Mo/abdata/stack.as"
#include "Mo/abdata/list.as"

#module mod_StrCalc_cnv

#include "header_inner.as"

//------------------------------------------------
// g[Nt|[hL@ɒ
//------------------------------------------------
#deffunc StrCalc_CnvToDePoland array ioQueue,  \
	local outQueue, local stkOperator, \
	local nowType, local nowData, local befOp, local befOpData, \
	local bEnd, local bBracketL, local bHigher
	
	dbgout "\nEt|[hL@ւ̕ϊ"
	
	// L[ƃX^bNp
	Queue_new outQueue(0)					// o͗pL[( tkType )
	Queue_new outQueue(1)					// o͗pL[( tkData )
	Stack_new stkOperator(0)				// ƗpX^bN( tkType )
	Stack_new stkOperator(1)				// ƗpX^bN( tkData )
	
;	dbgout strf( "(outQue(%d, %d), stkOp(%d, %d))", outQueue(0), outQueue(1), stkOperator(0), stkOperator(1) )
	
	PushToStack stkOperator, TkType_None, 0	// JnL
	
	bEnd = false
	
	repeat Queue_size( ioQueue(0) )
		
		gosub *LRenewData
		gosub *LProcConvert
		if ( bEnd ) { break }
		
	loop
	
	// G[
	if ( stt_error ) { return }
	
	/*
	// X^bN̉Zqׂďo͂
	repeat Stack_size( stkOperator )
		nowType = Stack_pop( stkOperator(0) )
		nowData = Stack_pop( stkOperator(1) )
		
		PushToQueue outQueue, nowType, nowData, DecodeToken( nowType, nowData )
	loop
	//*/
	
	// ioQueue ɏo̓L[߂
	foreach ioQueue
		Queue_delete ioQueue(cnt)
		ioQueue(cnt) = outQueue(cnt)
	loop
	
	// X^bN͕svȂ̂ō폜
	assert ( Stack_size( stkOperator ) == 0 )
	foreach stkOperator
		Stack_delete stkOperator(cnt)
	loop
	
#ifdef _MODE_STRCALC_DEBUG_OUTPUT
	dbgout "Et|[hL@ւ̕ϊ::O"
	Queue_dbglog ioQueue(1)
#endif
	return
	
*LRenewData
	nowType = Queue_peek( ioQueue(0), cnt )
	nowData = Queue_peek( ioQueue(1), cnt )
	dbgout dbgstr(nowType) + "\t : " + dbgstr(nowData)
	
	return
	
*LProcConvert
	//-----------------------------------------------
	//        ʎq or {e
	//-----------------------------------------------
	if ( IsValueType(nowType) && not IsBracketR(nowType) ) {
		PushToQueue outQueue, nowType, nowData		// l͑ɏo
		
	//-----------------------------------------------
	//        J}
	//-----------------------------------------------
	} elsif ( nowType == TkType_Comma ) {
		// ignore
		
	//-----------------------------------------------
	//        Zq, , IL
	//-----------------------------------------------
	} else {
	:*LOperator
		assert ( IsOperatorType(nowType) || IsBracket(nowType) || nowType == TkType_None )
		
		befOp     = Stack_peek( stkOperator(0) )	// ỎZq̎
		befOpData = Stack_peek( stkOperator(1) )	// f[^
		
	;	if ( befOp == TkType_PolyOp_Tuple ) { befOp = TkType_BinOp : befOpData = BinOp_Tuple }
		
		//--------------------------
		//  I
		// 
		// @  JnEI[L
		//--------------------------
		if ( nowType == TkType_None && befOp == TkType_None ) {
			gosub *LRemoveBefOp
			bEnd = true
			return
			
		//--------------------------
		// Dxꍇ
		// 
		// @ (O, ) = ( (, ) ), ( {, } ), ( [, ] )
		//--------------------------
		} elsif ( (befOp == TkType_ParenL && nowType == TkType_ParenR) || (befOp == TkType_ArgL && nowType == TkType_ArgR) || (befOp == TkType_BlockL && nowType == TkType_BlockR) || (befOp == TkType_ArrayL && nowType == TkType_ArrayR) || (befOp == TkType_IndexL && nowType == TkType_IndexR) || (befOp == TkType_TupleL && nowType == TkType_TupleR) ) {
			gosub *LRemoveBefOp
			
			switch ( nowType )
				case TkType_ParenR:
					swbreak
					
				case TkType_ArgR:
					PushToQueue outQueue, nowType, nowData, DecodeToken( nowType, nowData )		// ')' I
					nowType = TkType_PostfixOp
					nowData = PostfixOp_Call
					PushToQueue outQueue, nowType, nowData, DecodeToken( nowType, nowData )		// call
					swbreak
					
				case TkType_BlockR:
				case TkType_ArrayR:
				case TkType_TupleR:
					PushToQueue outQueue, nowType, nowData, DecodeToken( nowType, nowData )		// ʏI
					swbreak
					
				case TkType_IndexR:
					PushToQueue outQueue, nowType, nowData, DecodeToken( nowType, nowData )		// ']' I
					nowType = TkType_PostfixOp
					nowData = PostfixOp_Index
					PushToQueue outQueue, nowType, nowData, DecodeToken( nowType, nowData )		// index
					swbreak
					
				default:
					assert
			swend
			return
			
		//--------------------------
		// PZq
		// 
		// @ KUX^bNɐς
		//--------------------------
		} elsif ( nowType == TkType_PrefixOp || nowType == TkType_PostfixOp ) {
			if ( nowData == PrefixOp_Func ) {			// (=> x)  (() => x) ɒu
				PushToQueue outQueue, TkType_Omission, dbgcode("omission", 0)
				nowType = TkType_BinOp
				nowData = BinOp_Lambda
				goto *LPushoutNowOperator
			}
			
			if ( nowData == PostfixOp_Tuple ) {		// (x ,)  (x , ()) ɒu
			;	PushToQueue outQueue, TkType_Omission, dbgcode("omission", 0)
			;	nowType = TkType_BinOp
			;	nowData = BinOp_Tuple
				goto *LProcAsBinOp
			}
			
			gosub *LPushNowOperatorImpl
			
		//--------------------------
		// ̑
		// 
		// @ 񍀉Zq, Zq(,)
		// @ 
		// @ JnEI[L ...etc
		//--------------------------
		} else {
		:*LProcAsBinOp
		;/*
			// D惌xvZ
			opLevelBef = StrCalc_GetTokenPriorityLevel( befOp, befOpData, true )
			opLevelNow = StrCalc_GetTokenPriorityLevel( nowType, nowData, false )
			bHigher    = opLevelNow > opLevelBef
			
			dbgout "Dx: (" + opLevelBef + " " + which(bHigher, "<", ">") + " " + opLevelNow + ") = (" + DecodeToken(befOp, befOpData) + " " + which(bHigher, "<", ">") + " " + DecodeToken(nowType, nowData) + ")"
		/*/
			bHigher   = false
			bBracketL = false
			
			//  񍀉Zq
			if ( nowType == TkType_BinOp ) {
				opLevelNow = StrCalc_GetBinOpLevel( nowData )	// D惌x
				
				// O PZq ̏ꍇ
				if ( IsUnaryOp( befOp ) ) {
					//  low-priority ȑOuZq̗Dx * ̉
					// high-priority ȑOuZq̗Dx ^ ̉
					// O uZq ȂɑOD
					// @ ȏ̗DxȂẢZqD
					
					bHigher |= ( EnumRange_UniOp_LowPriory(befOpData)  && opLevelNow >= StrCalc_GetBinOpLevel(BinOp_Mul) )
					bHigher |= ( EnumRange_UniOp_HighPriory(befOpData) && opLevelNow >= StrCalc_GetBinOpLevel(BinOp_Pow) )
					bHigher &= not EnumRange_UniOp_Postfix(befOp)
					
				// O 񍀉Zq or Zq ̏ꍇ
				} elsif ( befOp == TkType_BinOp || IsPolyOp(befOp) ) {
					if ( befOp == TkType_BinOp ) {
						opLevelBef = StrCalc_GetBinOpLevel( befOpData )		// ỎZq̗D惌x
					} else {
						assert ( befOp == TkType_PolyOp_Tuple )
						opLevelBef = StrCalc_GetBinOpLevel( BinOp_Tuple )	//  , ̗Dx , ɓ
					}
					
					// ̕DxZq
					if ( opLevelNow > opLevelBef ) {
						bHigher = true
						
					// ƑO̗DxŁAE
					} else : if ( opLevelNow == opLevelBef && IsRightUnit(nowData) ) {
						bHigher = true
						
					// D悳Ȃ
					} else {
						// bHigher = false
					}
				}
				
			//  
			} elsif ( IsBracketL(nowType) ) {
				// O uZq or 񍀉Zq(Dx  ȏ) => OD
				if ( befOp == TkType_PostfixOp || (befOp == TkType_BinOp && EnumRange_BinOp_Assoc(befOpData)) ) {
					goto *LPushoutBeforeOperator
				} else {
					goto *LPushoutNowOperator
				}
			}
			
			// ǂ炩ʂH
			bBracketL = ( IsBracketL(befOp) || IsBracketL(nowType) )
		//*/
			
			// ̕D悳Aǂ炩ʁAOJnLÂǂꂩ
			if ( bHigher || bBracketL || befOp == TkType_None ) {
				:*LPushoutNowOperator
				gosub *LPushNowOperatorImpl		// ̉ZqX^bNɐς
				
				if ( IsBracketL(nowType) && nowType != TkType_ParenL ) {
					PushToQueue outQueue, nowType, nowData, DecodeToken( nowType, nowData )			// ʊJn
				}
				
				// <for:Z>
				if ( nowType == TkType_BinOp ) {
					// ?:  then-, else-Z
					if and( befOp == TkType_BinOp, befOpData == BinOp_Which, /* nowType == TkType_BinOp,*/ nowData == BinOp_Pair ) {
						PushToQueue outQueue, TkType_BlockR, dbgcode("} #/ end: short-then /#", 0)
						PushToQueue outQueue, TkType_BlockL, dbgcode("#/ begin: short-else /# {", 0)
						
					// rhs-Z
					} elsif ( IsShortCircuitRhs(nowData) ) {
						PushToQueue outQueue, TkType_BlockL, dbgcode("#/ begin: short-rhs /# {", 0)
					}
				}
				// </for:Z>
				
			// OőZqƂȂ
			} elsif ( (nowData == PostfixOp_Tuple || nowData == BinOp_Tuple) && befOp == TkType_PolyOp_Tuple ) {
				// ,
				if ( nowData == PostfixOp_Tuple ) {		// a, b... ',' ; a, b,  ',' c (Ōォ ,)   omission ǉ
					PushToQueue outQueue, TkType_Omission, dbgcode("omission", 0)
				}
				
				//  ++
				befOpData = (befOpData + 1) * which(nowData == PostfixOp_Tuple, -1, 1)	// ŌオP , Ȃ獀͕ɂĂ
				Deque_set stkOperator(1), befOpData, -1		// XV
				
			// łȂ ( O̕D悳邩ADxō )
			} else {
				:*LPushoutBeforeOperator
				dbgout dbgpair(befOp, befOpData)
				gosub *LRemoveBefOp		// ỎZqX^bN菜
				
				// <for:Z>
				if ( befOp == TkType_BinOp ) {
					// ?:  else-Z
					if ( befOpData == BinOp_Pair ) {
						if ( Stack_peek( stkOperator(0) ) == TkType_BinOp && Stack_peek( stkOperator(1) ) == BinOp_Which ) {	// : ̂ɈO ?
							PushToQueue outQueue, TkType_BlockR, dbgcode("} #/ end: short-else /#", 0)		// [else ] I
						}
						
					// ?  rhs-Z (Ōɏo͂̂ : łȂꍇAthen-Zł͂Ȃ)
					} elsif and( befOpData == BinOp_Which, Queue_peek(outQueue(0), Queue_size(outQueue(0)) - 1) != TkType_BinOp || Queue_peek(outQueue(1), Queue_size(outQueue(1)) - 1) != BinOp_Pair ) {
						PushToQueue outQueue, TkType_BlockR, dbgcode("} #/ end: short-rhs /#", 0)
						
					// ̑ (?ȊO)  rhs-Z
					} elsif ( IsShortCircuitRhs(befOpData) && befOpData != BinOp_Which ) {
						PushToQueue outQueue, TkType_BlockR, dbgcode("} #/ end: short-rhs /#", 0)
					}
				}
				// </for:Z>
				
				gosub *LPushBeforeOperatorImpl
				
				goto *LOperator			// x now 
			}
			//*/
		}
		
	:*LEndOperatorProc
		;
	}
	
	return
	
*LPushNowOperatorImpl
	dbgout dbgpair(befOp, befOpData)
	dbgout dbgpair(nowType, nowData)
	
	if ( nowData == PostfixOp_Tuple || nowData == BinOp_Tuple ) {	// (x, y)  poly operator , ( x, y, ... )
		if ( nowData == PostfixOp_Tuple ) {
			PushToQueue outQueue, TkType_Omission, dbgcode("omission", 0)		// (x ,)  (x , ())
		}
		nowType = TkType_PolyOp_Tuple
		nowData = 2 * which(nowData == PostfixOp_Tuple, -1, 1)		// ŌオP , Ȃ畉ɂĂ
	}
	
;	PushToStack stkOperator, befOp,   befOpData, DecodeToken( befOp,   befOpData )		// Ôςݒ
	PushToStack stkOperator, nowType, nowData,   DecodeToken( nowType, nowData   )		// ̂ς
	return
	
*LPushBeforeOperatorImpl
	PushToQueue outQueue, befOp, befOpData, DecodeToken( befOp,   befOpData )			// ỎZqo
	return
	
*LRemoveBefOp
	repeat 2 : Stack_remove stkOperator(cnt) : loop
	return
	
//##########################################################
//        ̑
//##########################################################
//------------------------------------------------
// ̗Dxx擾
// 
// @ ȌȂƂ JnEI[L =>  D
//------------------------------------------------
#defcfunc StrCalc_GetTokenPriorityLevel int nowType, var nowData, int bBef
	
	if ( IsBracketR(nowType) ) { return which( bBef, 2, 1 ) }		// ɂD
	if ( IsBracketL(nowType) ) {
		if ( bBef ) { return 1 }
		if ( eq_or( nowType, TkType_ParenL, TkType_ArrayL, TkType_BlockL, TkType_TupleL ) ) {
			return 0xFFFF
		} else {
			return StrCalc_GetUniOpLevel( PostfixOp_Call, bBef )
		}
	}
	if ( IsPolyOp(nowType) ) {
		if ( nowData < 0 ) {		//  => Ō , P
			return StrCalc_GetUniOpLevel( PostfixOp_Tuple, bBef )
		} else {
			return StrCalc_GetBinOpLevel( BinOp_Tuple, bBef )
		}
	}
	
	if ( IsUnaryOp(nowType) )      { return StrCalc_GetUniOpLevel( nowData, bBef ) }
	if ( nowType == TkType_BinOp ) { return StrCalc_GetBinOpLevel( nowData, bBef ) }
	if ( nowType == TkType_None )  { return 0 }
	assert
	
//------------------------------------------------
// PZq̗Dxx擾
// 
// @prm bBef: rΏۂɑ΂āAPZqɂ
//------------------------------------------------
#defcfunc StrCalc_GetUniOpLevel int uniOpType, int bBef
	
	if ( bBef ) {
		if ( EnumRange_UniOp_Postfix(uniOpType) ) {
			return 0xFFFF		// ŋ (ex: a! * c  񍀉Zq * ܂͌uPZq * c ł ! D)
			
		} elsif ( EnumRange_UniOp_LowPriory(uniOpType) ) {
			return StrCalc_GetBinOpLevel(BinOp_Mul, false) - 1		//  * Ⴂ
			
		} elsif ( EnumRange_UniOp_HighPriory(uniOpType) ) {
			return StrCalc_GetBinOpLevel(BinOp_Pow, false) - 1		// p ^ Ⴂ
			
		} else : assert
		
	} else {
		if ( EnumRange_UniOp_Postfix(uniOpType) ) {
			if ( uniOpType == PostfixOp_Tuple ) {
				return StrCalc_GetBinOpLevel(BinOp_Tuple, true)			//  , Ɠ
			} else {
				return StrCalc_GetBinOpLevel(BinOp_Assoc, true) - 1		// Az . Ⴂ
			}
		} else {
			return 0xFFFF		// ŋ (ex: b * !a  񍀉Zq * ł ! D)
		}
	}
	
//------------------------------------------------
// 񍀉Zq̗Dxx擾
// 
// @ ōAEŉEɂƂADxZ
// @prm bBef: rΏۂɑ΂āA񍀉Zqۂ
//------------------------------------------------
#defcfunc StrCalc_GetBinOpLevel int binOpType, int bBef
	return ((StrCalc_GetBinOpLevelImpl(binOpType) + 10) << 3) + which(bBef == not IsRightUnit(binOpType), 2, 0)
	
#defcfunc StrCalc_GetBinOpLevelImpl int binOpType
	if ( numrg( binOpType, BinOp_Lv0, BinOp_Lv1 - 1 ) ) {
		return 0
		
	} else : if ( numrg( binOpType, BinOp_Lv1, BinOp_Lv2 - 1 ) ) {
		return 1
		
	} else : if ( numrg( binOpType, BinOp_Lv2, BinOp_Lv3 - 1 ) ) {
		return 2
		
	} else : if ( numrg( binOpType, BinOp_Lv3, BinOp_Lv4 - 1 ) ) {
		return 3
		
	} else : if ( numrg( binOpType, BinOp_Lv4, BinOp_Lv5 - 1 ) ) {
		return 4
		
	} else : if ( numrg( binOpType, BinOp_Lv5, BinOp_Lv6 - 1 ) ) {
		return 5
		
	} else : if ( numrg( binOpType, BinOp_Lv6, BinOp_Lv7 - 1 ) ) {
		return 6
		
	} else : if ( numrg( binOpType, BinOp_Lv7, BinOp_Lv8 - 1 ) ) {
		return 7
		
	} else : if ( numrg( binOpType, BinOp_Lv8, BinOp_Lv9 - 1 ) ) {
		return 8
		
	} else : if ( numrg( binOpType, BinOp_Lv9, BinOp_Lv10 - 1 ) ) {
		return 9
		
	} else : if ( numrg( binOpType, BinOp_Lv10, BinOp_Lv11 - 1 ) ) {
		return 10
		
	} else : if ( numrg( binOpType, BinOp_Lv11, BinOp_Lv12 - 1 ) ) {
		return 11
		
	} else : if ( numrg( binOpType, BinOp_Lv12, BinOp_Lv13 - 1 ) ) {
		return 12
		
	} else : if ( numrg( binOpType, BinOp_Lv13, BinOp_Lv14 - 1 ) ) {
		return 13
		
	} else : if ( numrg( binOpType, BinOp_Lv14, BinOp_Lv15 - 1 ) ) {
		return 14
		
	} else : if ( numrg( binOpType, BinOp_Lv15, BinOp_Lv16 - 1 ) ) {
		return 15
		
	} else : if ( numrg( binOpType, BinOp_Lv16, BinOp_Lv17 - 1 ) ) {
		return 16
		
	} else : if ( numrg( binOpType, BinOp_Lv17, BinOp_Lv18 - 1 ) ) {
		return 17
		
	} else : if ( numrg( binOpType, BinOp_Lv18, BinOp_Lv19 - 1 ) ) {
		return 18
		
	} else : if ( numrg( binOpType, BinOp_Lv19, BinOp_Max - 1 ) ) {
		return 19
	}
	
	return 0
	
#global

#endif
