// StrCalc - valize

#ifndef IG_MODULE_STRCALC_VALIZE_AS
#define IG_MODULE_STRCALC_VALIZE_AS

#include "Mo/abdata/queue.as"

#module mod_StrCalc_valize

#include "header_inner.as"

//------------------------------------------------
// l
// 
// @cnv: [g[N, g[N]
//     [l̎, l̏]
// @ ȒPȒuȂ̂ŁAL[̗vfɏ㏑B
//------------------------------------------------
#deffunc StrCalc_Valize array ioQueue,  \
	local outQueue, local nowType, local nowData, local valData, local valType, local idx, local lenQueue
	
	dbgout "\nEl(valize)"
	lenQueue = Queue_size( ioQueue(0) )
	
	repeat lenQueue						// 吔[v
		idx = cnt
		
		gosub *LPopNextData				// f[^̍XV
		gosub *LProcValize				// 򏈗
		if ( stt_error ) { assert : break }
		
	loop
	if ( stt_error ) { return }
	
#ifdef _MODE_STRCALC_DEBUG_OUTPUT
	dbgout "Eg[Nl::O"
	Queue_dbglog ioQueue(0)
#endif
	return
	
*LPopNextData
	assert( idx < lenQueue )
	
	nowType = Queue_peek( ioQueue(0), idx )
	nowData = Queue_peek( ioQueue(1), idx )
	
	return
	
*LProcValize
;	dbgout "next: ( " + nowType + ", " + nowToken + " )"
	
	valType = Valtype_Error
	valData = nowData
	
	switch ( nowType )
		// l
		case TkType_Ident:  valType = Valtype_Ident  : swbreak
		case TkType_Int:    valType = Valtype_Int    : swbreak
		case TkType_Double: valType = Valtype_Double : swbreak
		case TkType_String: valType = Valtype_String : swbreak
		
		// L (Valtype_Mark)
		case TkType_Omission:
		case TkType_ArgL:
		case TkType_ArgR:
		case TkType_BlockL:
		case TkType_BlockR:
		case TkType_ArrayL:
		case TkType_ArrayR:
		case TkType_IndexL:
		case TkType_IndexR:
		case TkType_TupleL:
		case TkType_TupleR:
			valType = Valtype_Mark
			valData = nowType
			swbreak
			
		// Zq
		case TkType_PrefixOp:
		case TkType_PostfixOp:
			valType = Valtype_OpUni
			swbreak
			
		case TkType_BinOp:
			valType = Valtype_OpBin
			swbreak
			
		case TkType_PolyOp_Tuple:
			valType = Valtype_OpPoly
			valData = nowData
			swbreak
			
		// !error
		default:
			logmes "lłȂ傪 { [" + cnt + "], nowType: " + nowType + ", nowData: " + nowData + " }"
			assert
	swend
	
	// ioQueue 
	Queue_set ioQueue(0), valData, idx
	Queue_set ioQueue(1), valType, idx
	
	return
	
#global

#endif
